//motor reune las funciones de la IAPWS-IF97 para calcular variables
//termodinmicas del agua
//Copyright (C) 2006  David F. Suescun R. daisukeing@gmail.com
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

#define RETURN_VALUE resulmot
#include <args.h>
#include <estack.h>
#include "region1.h"
#include "region2.h" 
#include "region4.h"
#include "propiedades.h" 

// Main Function
void _main(void)
{
  ESI argptr = top_estack;
  int prop = GetIntArg (argptr);
  float val = GetFloatArg (argptr);
  float val2 = GetFloatArg (argptr);
  float val3 = GetFloatArg (argptr);
  //float val4 = GetFloatArg (argptr);
  while (GetArgType (top_estack) != END_TAG)  // Clean up arguments
    top_estack = next_expression_index (top_estack);
  top_estack--;
/*LISTA DE prop
1.	Tsat(p)
2.	psat(T)
3.	xpt(h,p,T)
4.	Tsaths (h,s)
5.	T2ph(p,h)
6.	T2ps(p,s)
7.	p2hs(h,s)
8.	T2hs(h,s)
9.	pb23(T)
10.	T1h(p,h)
11.	T1s(p,s)
12.	pT1hs(h,s)
13.	T1hs(h,s)
14.	liq_prop(p,T,calcvcp) Agua lquida Comprimida
15.	vap_prop(p,T,calcvcp) Vapor de Agua Sobrecalentado
16.	h2osatpt(p,T,xhs) Propiedades de equilibrio lquido-vapor
17.	h2osaths(h,s) Propiedades de equilibrio lquido-vapor
*/
 switch (prop)
{
	case 1:
		push_Float (Tsat(val)); break;
	case 2:
		push_Float (psat(val)); break;
	case 3:
		push_Float (xpt(val,val2,val3)); break;
	case 4:
		push_Float (Tsaths(val,val2)); break;
	case 5:
		push_Float (T2ph(val,val2)); break;
	case 6:
		push_Float (T2ps(val,val2)); break;
	case 7:
		pT2hs(val,val2); break;
	case 8:
		push_Float (T2hs(val,val2)); break;
	case 9:
		push_Float (pb23(val)); break;
	case 10:
		push_Float (T1h(val,val2)); break;
	case 11:
		push_Float (T1s(val,val2)); break;
	case 12:
		p1hs(val,val2); break;
	case 13:
		push_Float (T1hs(val,val2)); break;
	case 14:
		liq_prop(val,val2,val3); break;
	case 15:
		vap_prop(val,val2,val3); break;
	case 16:
		h2osatpt(val,val2,val3); break;
	case 17:
		h2osaths(val,val2); break;
	default:
		push_zstr ("ERROR: No existe"); break;
  }
}
